> ## Documentation Index
> Fetch the complete documentation index at: https://razorpay-60c89f9a-mintlify-audit-missing-sections-1778528421.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Integration Steps (Android)

> Follow these steps to integrate your React Native Android application:

* **1. Build Integration**: Integrate React Android Standard Checkout.

* **2. Test Integration**: Test the integration by making a test payment.

* **3. Go-live Checklist**: Check the go-live checklist.

<Info>
  **Handy Tips**

  The **compileSdkVersion** is the version of Android. Increase the value of **minSdkVersion** to at least 19 in the build.gradle file in the Android folder to work with the latest Android SDK Build Tools version. Using it with a lower **minSdkVersion** version will lead to errors.
</Info>

<Warning>
  **Watch Out!**

  If you use M1 MacBook, you need to make [these changes](#m1-macbook-changes) in your `podfile`.
</Warning>

## 1. Build Integration

Follow the steps given below:

### 1.1 Install Razorpay React Native SDK

Install the SDK using the following `npm` command in the **Terminal** window. If you are using Windows, please use **Git Bash** instead of the **Command Prompt** window. Ensure that you run this code within your React Native project folder in the **Terminal** window.

```node:Installation Code theme={null}
//using npm
$ npm install react-native-razorpay --save
```

Additionally, run the code given below if you are using `yarn` or `expo`:

```node:Installation Code using yarn  theme={null}
// using yarn
$ yarn add react-native-razorpay
```

```node:Installation Code using expo theme={null}
// for expo
$ npx expo install react-native-razorpay
```

### 1.2 Run React Native App

Run the React Native app.

```node: Run theme={null}
npx react-native run-android
```

This links the SDK with your React Native project.

Expo Application

After adding the `react-native-razorpay` package, use the option to prebuild the app. This generates the **android** platform folders in the project to use native-modules.

```node: Run theme={null}
npx expo prebuild
```

The application is installed on the device/emulator.

```node: theme={null}
npx expo run:[android] --device
```

### 1.3 Create an Order in Server

**Order is an important step in the payment process.**

* An order should be created for every payment.
* You can create an order using the [Orders API](#api-sample-code). It is a server-side API call. Know how to [authenticate](/payments/dashboard/account-settings/api-keys#generate-api-keys) Orders API.
* The `order_id` received in the response should be passed to the checkout. This ties the order with the payment and secures the request from being tampered.

<Warning>
  **Watch Out!**

  Payments made without an `order_id` cannot be captured and will be automatically refunded. You must create an order before initiating payments to ensure proper payment processing.

  You can create an order using:

  Use this endpoint to create an order using the Orders API.

  /orders

  ````curl: Curl theme={null}
  curl -X POST https://api.razorpay.com/v1/orders 
  -U [YOUR_KEY_ID]:[YOUR_KEY_SECRET]
  -H 'content-type:application/json'
  -d '{
      "amount": 50000,
      "currency": "INR",
      "receipt": "qwsaq1",
      "partial_payment": true,
      "first_payment_min_amount": 230
  }'
  ```java: Java
  RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  JSONObject orderRequest = new JSONObject();
  orderRequest.put("amount", 50000); // amount in the smallest currency unit
  orderRequest.put("currency", "INR");
  orderRequest.put("receipt", "order_rcptid_11");

  Order order = razorpay.Orders.create(orderRequest);
  } catch (RazorpayException e) {
  // Handle Exception
  System.out.println(e.getMessage());
  }
  ```Python: Python
  import razorpay
  client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

  DATA = {
      "amount": 50000,
      "currency": "INR",
      "receipt": "receipt#1",
      "notes": {
          "key1": "value3",
          "key2": "value2"
      }
  }
  client.order.create(data=DATA)
  ```php: PHP
  $api = new Api($key_id, $secret);

  $api->order->create(array('receipt' => '123', 'amount' => 50000, 'currency' => 'INR', 'notes'=> array('key1'=> 'value3','key2'=> 'value2')));
  ```csharp: .NET
  RazorpayClient client = new RazorpayClient(your_key_id, your_secret);

  Dictionary options = new Dictionary();
  options.Add("amount", 50000); // amount in the smallest currency unit
  options.add("receipt", "order_rcptid_11");
  options.add("currency", "INR");
  Order order = client.Order.Create(options);
  ```ruby: Ruby
  require "razorpay"
  Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

  options = amount: 50000, currency: 'INR', receipt: ''
  order = Razorpay::Order.create
  ```javascript: Node.js
  var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

  instance.orders.create({
  amount: 50000,
  currency: "INR",
  receipt: "receipt#1",
  notes: {
      key1: "value3",
      key2: "value2"
  }
  })
  ```go: Go
  import ( razorpay "github.com/razorpay/razorpay-go" )
  client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

  data := map[string]interface{}{
  "amount": 50000,
  "currency": "INR",
  "receipt": "some_receipt_id"
  }
  body, err := client.Order.Create(data)
  ````

  ````json: Success Response theme={null}
  {
      "id": "order_IluGWxBm9U8zJ8",
      "entity": "order",
      "amount": 50000,
      "amount_paid": 0,
      "amount_due": 50000,
      "currency": "INR",
      "receipt": "rcptid_11",
      "offer_id": null,
      "status": "created",
      "attempts": 0,
      "notes": [],
      "created_at": 1642662092
  }
  ```json: Failure Response
  {
  "error": {
      "code": "BAD_REQUEST_ERROR",
      "description": "Order amount less than minimum amount allowed",
      "source": "business",
      "step": "payment_initiation",
      "reason": "input_validation_failed",
      "metadata": {},
      "field": "amount"
  }
  }
  ````

  You can use the Postman workspace below to create an order:

  [](https://www.postman.com/razorpaydev/workspace/razorpay-public-workspace/request/12492020-6f15a901-06ea-4224-b396-15cd94c6148d)
</Warning>

<Info>
  **Handy Tips**

  Under the **Authorization** section in Postman, select **Basic Auth** and add the Key Id and secret as the Username and Password, respectively.

  You can create an order manually by integrating the API sample codes on your server.

  Request Parameters

  `amount` *mandatory*
  : `integer` The transaction amount, expressed in the currency subunit. For example, for an actual amount of , the value of this field should be `22225`.

  `currency` *mandatory*
  : `string` The currency in which the transaction should be made.  See the [list of supported currencies](/payments/international-payments#supported-currencies). Length must be of 3 characters.

  `receipt` *optional*
  : `string` Your receipt id for this order should be passed here. Maximum length is 40 characters.

  `notes` *optional*
  : `json object` Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, `"note_key": "Beam me up Scotty”`.

  `partial_payment` *optional*
  : `boolean` Indicates whether the customer can make a partial payment. Possible values:

  * `true`: The customer can make partial payments.
  * `false` (default): The customer cannot make partial payments.

  `first_payment_min_amount` *optional*
  : `integer` Minimum amount that must be paid by the customer as the first partial payment. For example, if an amount of ₹7,000 is to be received from the customer in two installments of #1 - ₹5,000, #2 - ₹2,000, then you can set this value as `500000`. This parameter should be passed only if `partial_payment` is `true`.
</Info>

### Response Parameters

Descriptions for the response parameters are present in the [Orders Entity](/api/orders/entity) parameters table.

### Error Response Parameters

The error response parameters are available in the [API Reference Guide](/api/orders/create).

### 1.4 Add Razorpay Checkout Options to .js File

To integrate the Razorpay Checkout with your React Native app, you must add the Checkout Display Options in the **.js** file.

Open the **.js** file in your project folder and perform the following:

1. Import the `RazorpayCheckout` module to your component.

   ```js: Import Razorpay Checkout Module theme={null}
   import RazorpayCheckout from 'react-native-razorpay';
   ```

2. Call the `RazorpayCheckout.open` method with the payment options. The method returns a JS Promise where the `then` part corresponds to a successful payment and the `catch` part corresponds to payment failure.

```Javascript: Checkout Options theme={null}
 {
    var options = {
    description: 'Credits towards consultation',
    image: 'https://i.imgur.com/3g7nmJC.jpg',
    currency: 'INR',
    key: '',
    amount: '50000',
    name: 'Acme Corp',
    order_id: 'order_DslnoIgkIDL8Zt',//Replace this with an order_id created using Orders API.
    prefill: {
      email: 'gaurav.kumar@example.com',
      contact: '+919876543210',
      name: 'Gaurav Kumar'
    },
    theme: {color: '#53a20e'}
  }
  RazorpayCheckout.open(options).then((data) => {
    // handle success
    alert(`Success: ${data.razorpay_payment_id}`);
  }).catch((error) => {
    // handle failure
    alert(`Error: ${error.code} | ${error.description}`);
  });
}}>
```

Checkout Options

You must pass these parameters in Checkout to initiate the payment.

`key` *mandatory*
: `string` API Key ID generated from the Dashboard.

`amount` *mandatory*
: `integer` Payment amount in the smallest currency subunit. For example, if the amount to be charged is , enter `222250` in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.

<Warning>
  **Watch Out!**

  As per payment guidelines, you should pass the last decimal number as 0 for three decimal currency payments. For example, if you want to charge a customer 99.991 KD for a transaction, you should pass the value for the amount parameter as `99990` and not `99991`.

  `currency` *mandatory*
  : `string` The currency in which the payment should be made by the customer. See the list of [supported currencies](/payments/international-payments#supported-currencies).
</Warning>

<Info>
  **Handy Tips**

  Razorpay has added support for zero decimal currencies, such as JPY, and three decimal currencies, such as KWD, BHD, and OMR, allowing businesses to accept international payments in these currencies. Know more about [Currency Conversion](/payments/international-payments/currency-conversion) (May 2024).

  `name` *mandatory*
  : `string` Your Business/Enterprise name shown on the Checkout form. For example, **Acme Corp**.

  `description` *optional*
  : `string` Description of the purchase item shown on the Checkout form. It should start with an alphanumeric character.

  `image` *optional*
  : `string` Link to an image (usually your business logo) shown on the Checkout form. Can also be a **base64** string if you are not loading the image from a network.

  `order_id` *mandatory*
  : `string` Order ID generated via [Orders API](/api/orders).

  `prefill`
  : `object` You can prefill the following details at Checkout.
</Info>

<Info>
  **Boost Conversions and Minimise Drop-offs**

  * Autofill customer contact details, especially phone number to ease form completion. Include customer’s phone number in the `contact` parameter of the JSON request's `prefill` object. Format: +(country code)(phone number). Example: "contact": "+919000090000".
  * This is not applicable if you do not collect customer contact details on your website before checkout, have Shopify stores or use any of the no-code apps.

    `name` *optional*
    : `string` Cardholder's name to be prefilled if customer is to make card payments on Checkout. For example, **Gaurav Kumar**.

    `email` *optional*
    : `string` Email address of the customer.

    `contact` *optional*
    : `string` Phone number of the customer. The expected format of the phone number is `+ {country code}{phone number}`. If the country code is not specified, `91` will be used as the default value. This is particularly important while prefilling `contact` of customers with phone numbers issued outside India. **Examples**:

    * +14155552671 (a valid non-Indian number)
    * +919977665544 (a valid Indian number).
      If 9977665544 is entered, `+91` is added to it as +919977665544.

    `method` *optional*
    : `string` Pre-selection of the payment method for the customer. Will only work if `contact` and `email` are also prefilled. Possible values:

    * `card`

    * `netbanking`

    * `wallet`

    * `upi`

    * `emi`

  `notes` *optional*
  : `object` Set of key-value pairs that can be used to store additional information about the payment. It can hold a maximum of 15 key-value pairs, each 256 characters long (maximum).

  `theme`
  : `object` Thematic options to modify the appearance of Checkout.

  `color` *optional*
  : `string` Enter your brand colour's HEX code to alter the text, payment method icons and CTA (call-to-action) button colour of the Checkout form.

  `backdrop_color` *optional*
  : `string` Enter a HEX code to change the Checkout's backdrop colour.

  `modal`
  : `object` Options to handle the Checkout modal.

  `backdropclose` *optional*
  : `boolean` Indicates whether clicking the translucent blank space outside the Checkout form should close the form. Possible values:

  * `true`: Closes the form when your customer clicks outside the checkout form.
  * `false` (default): Does not close the form when customer clicks outside the checkout form.

  `escape` *optional*
  : `boolean` Indicates whether pressing the **escape** key should close the Checkout form. Possible values:

  * `true` (default): Closes the form when the customer presses the **escape** key.
  * `false`: Does not close the form when the customer presses the **escape** key.

  `handleback` *optional*
  : `boolean` Determines whether Checkout must behave similar to the browser when back button is pressed. Possible values:

  * `true` (default): Checkout behaves similarly to the browser. That is, when the browser's back button is pressed, the Checkout also simulates a back press. This happens as long as the Checkout modal is open.
  * `false`: Checkout does not simulate a back press when browser's back button is pressed.

  `confirm_close` *optional*
  : `boolean` Determines whether a confirmation dialog box should be shown if customers attempts to close Checkout. Possible values:

  * `true`: Confirmation dialog box is shown.
  * `false` (default): Confirmation dialog box is not shown.

  `ondismiss` *optional*
  : `function` Used to track the status of Checkout. You can pass a modal object with `ondismiss: function()\{\}` as options. This function is called when the modal is closed by the user. If `retry` is `false`, the `ondismiss` function is triggered when checkout closes, even after a failure.

  `animation` *optional*
  : `boolean` Shows an animation before loading of Checkout. Possible values:

  * `true`(default): Animation appears.
  * `false`: Animation does not appear.

  `subscription_id` *optional*
  : `string` If you are accepting recurring payments using Razorpay Checkout, you should pass the relevant `subscription_id` to the Checkout. Know more about [Subscriptions on Checkout](/api/payments/subscriptions#checkout-integration).

  `subscription_card_change` *optional*
  : `boolean` Permit or restrict customer from changing the card linked to the subscription. You can also do this from the [hosted page](/payments/subscriptions/payment-retries#update-the-payment-method-via-our-hosted-page). Possible values:

  * `true`: Allow the customer to change the card from Checkout.
  * `false` (default): Do not allow the customer to change the card from Checkout.

  `recurring` *optional*
  : `boolean` Determines if you are accepting [recurring (charge-at-will) payments on Checkout](/api/payments/recurring-payments) via instruments such as emandate, paper NACH and so on. Possible values:

  * `true`: You are accepting recurring payments.
  * `false` (default): You are not accepting recurring payments.

  `callback_url` *optional*
  : `string` Customers will be redirected to this URL on successful payment. Ensure that the domain of the Callback URL is allowlisted.

  `redirect` *optional*
  : `boolean` Determines whether to post a response to the event handler post payment completion or redirect to Callback URL. `callback_url` must be passed while using this parameter. Possible values:

  * `true`: Customer is redirected to the specified callback URL in case of payment failure.
  * `false` (default): Customer is shown the Checkout popup to retry the payment with the suggested next best option.

  `customer_id` *optional*
  : `string` Unique identifier of customer. Used for:

  * [Local saved cards feature](/payments/payment-methods/cards/features/saved-cards#manage-saved-cards).
  * Static bank account details on Checkout in case of [Bank Transfer payment method](/payments/payment-methods/bank-transfer).

  `remember_customer` *optional*
  : `boolean` Determines whether to allow saving of cards. Can also be configured via the [Dashboard](/payments/dashboard/account-settings/checkout-features#flash-checkout). Possible values:

  * `true`: Enables card saving feature.
  * `false` (default): Disables card saving feature.

  `timeout` *optional*
  : `integer` Sets a timeout on Checkout, in seconds. After the specified time limit, the customer will not be able to use Checkout.
</Info>

<Warning>
  **Watch Out!**

  Some browsers may pause `JavaScript` timers when the user switches tabs, especially in power saver mode. This can cause the checkout session to stay active beyond the set timeout duration.

  `readonly`
  : `object` Marks fields as read-only.

  `contact` *optional*
  : `boolean` Used to set the `contact` field as readonly. Possible values:

  * `true`: Customer will not be able to edit this field.
  * `false` (default): Customer will be able to edit this field.

  `email` *optional*
  : `boolean` Used to set the `email` field as readonly. Possible values:

  * `true`: Customer will not be able to edit this field.
  * `false` (default): Customer will be able to edit this field.

  `name` *optional*
  : `boolean` Used to set the `name` field as readonly. Possible values:

  * `true`: Customer will not be able to edit this field.
  * `false` (default): Customer will be able to edit this field.

  `hidden`
  : `object` Hides the contact details.

  `contact` *optional*
  : `boolean` Used to set the `contact` field as optional. Possible values:

  * `true`: Customer will not be able to view this field.
  * `false` (default): Customer will be able to view this field.

  `email` *optional*
  : `boolean` Used to set the `email` field as optional. Possible values:

  * `true`: Customer will not be able to view this field.
  * `false` (default): Customer will be able to view this field.

  `send_sms_hash` *optional*
  : `boolean` Used to auto-read OTP for cards and netbanking pages. Applicable from Android SDK version 1.5.9 and above. Possible values:

  * `true`: OTP is auto-read.
  * `false` (default): OTP is not auto-read.

  `allow_rotation` *optional*
  : `boolean` Used to rotate payment page as per screen orientation. Applicable from Android SDK version 1.6.4 and above. Possible values:

  * `true`: Payment page can be rotated.
  * `false` (default): Payment page cannot be rotated.

  `retry` *optional*
  : `object` Parameters that enable retry of payment on the checkout.

  `enabled`
  : `boolean` Determines whether the customers can retry payments on the checkout. Possible values:

  * `true` (default): Enables customers to retry payments.
  * `false`: Disables customers from retrying the payment.

  `max_count`
  : `integer` The number of times the customer can retry the payment. We recommend you to set this to 4. Having a larger number here can cause loops to occur.
</Warning>

<Warning>
  **Watch Out!**

  Web Integration does not support the `max_count` parameter. It is applicable only in Android and iOS SDKs.

  `config` *optional*
  : `object` Parameters that enable checkout configuration. Know more about how to [configure payment methods on Razorpay standard checkout](/payments/payment-gateway/web-integration/standard/configure-payment-methods).

  `display`
  : `object` Child parameter that enables configuration of checkout display language.

  `language`
  : `string` The language in which checkout should be displayed. Possible values:

  * `en`: English
  * `ben`: Bengali
  * `hi`: Hindi
  * `mar`: Marathi
  * `guj`: Gujarati
  * `tam`: Tamil
  * `tel`: Telugu
</Warning>

### 1.5 Store Fields in Your Server

A successful payment returns the following fields to the Checkout form.

Success Callback

* You need to store these fields in your server.
* You can confirm the authenticity of these details by verifying the signature in the next step.

```json: Success Callback theme={null}
{
  "razorpay_payment_id": "pay_29QQoUBi66xm2f",
  "razorpay_order_id": "order_9A33XWu170gUtm",
  "razorpay_signature": "9ef4dffbfd84f1318f6739a3ce19f9d85851857ae648f114332d8401e0949a3d"
}
```

`razorpay_payment_id`
: `string` Unique identifier for the payment returned by Checkout **only** for successful payments.

`razorpay_order_id`
: `string` Unique identifier for the order returned by Checkout.

`razorpay_signature`
: `string` Signature returned by the Checkout. This is used to verify the payment.

### 1.6 Verify Payment Signature

This is a mandatory step to confirm the authenticity of the details returned to the Checkout form for successful payments.

To verify the `razorpay_signature` returned to you by the Checkout form:

1. Create a signature in your server using the following attributes:
   * `order_id`: Retrieve the `order_id` from your server. Do not use the `razorpay_order_id` returned by Checkout.
   * `razorpay_payment_id`: Returned by Checkout.
   * `key_secret`: Available in your server. The `key_secret` that was generated from the [Dashboard](/payments/dashboard/account-settings/api-keys#generate-api-keys).

2. Use the SHA256 algorithm, the `razorpay_payment_id` and the `order_id` to construct a HMAC hex digest as shown below:

   ```html: HMAC Hex Digest theme={null}
   generated_signature = hmac_sha256(order_id + "|" + razorpay_payment_id, secret);

     if (generated_signature == razorpay_signature) {
       payment is successful
     }
   ```

3. If the signature you generate on your server matches the `razorpay_signature` returned to you by the Checkout form, the payment received is from an authentic source.

### Generate Signature on Your Server

Given below is the sample code for payment signature verification:

````java: Java theme={null}
RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

String secret = "EnLs21M47BllR3X8PSFtjtbd";

JSONObject options = new JSONObject();
options.put("razorpay_order_id", "order_IEIaMR65cu6nz3");
options.put("razorpay_payment_id", "pay_IH4NVgf4Dreq1l");
options.put("razorpay_signature", "0d4e745a1838664ad6c9c9902212a32d627d68e917290b0ad5f08ff4561bc50f");

boolean status =  Utils.verifyPaymentSignature(options, secret);

```php: PHP
$api = new Api($key_id, $secret);

$api->utility->verifyPaymentSignature(array('razorpay_order_id' => $razorpayOrderId, 'razorpay_payment_id' => $razorpayPaymentId, 'razorpay_signature' => $razorpaySignature));

```ruby: Ruby
require "razorpay"
Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

payment_response = {
       razorpay_order_id: 'order_IEIaMR65cu6nz3',
       razorpay_payment_id: 'pay_IH4NVgf4Dreq1l',
       razorpay_signature: '0d4e745a1838664ad6c9c9902212a32d627d68e917290b0ad5f08ff4561bc50f'
     }
Razorpay::Utility.verify_payment_signature(payment_response)

```python: Python
import razorpay
client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

client.utility.verify_payment_signature({
  'razorpay_order_id': razorpay_order_id,
  'razorpay_payment_id': razorpay_payment_id,
  'razorpay_signature': razorpay_signature
  })

```c: .NET
RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

Dictionary options = new Dictionary();
options.Add("razorpay_order_id", "order_IEIaMR65");
options.Add("razorpay_payment_id", "pay_IH4NVgf4Dreq1l");
options.Add("razorpay_signature", "0d4e745a1838664ad6c9c9902212a32d627d68e917290b0ad5f08ff4561bc50");

Utils.verifyPaymentSignature(options);

```nodejs: Node.js
var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

var { validatePaymentVerification, validateWebhookSignature } = require('./dist/utils/razorpay-utils');
validatePaymentVerification({"order_id": razorpayOrderId, "payment_id": razorpayPaymentId }, signature, secret);

```Go: Go
import ( razorpay "github.com/razorpay/razorpay-go" )
client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

params := map[string]interface{}{
 "razorpay_order_id": "order_IEIaMR65cu6nz3",
 "razorpay_payment_id": "pay_IH4NVgf4Dreq1l",
}

signature := "0d4e745a1838664ad6c9c9902212a32d627d68e917290b0ad5f08ff4561bc50f";
secret := "EnLs21M47BllR3X8PSFtjtbd";
utils.VerifyPaymentSignature(params, signature, secret)
````

### Post Signature Verification

After you have completed the integration, you can [set up webhooks](/webhooks/setup-edit-payments), make test payments, replace the test key with the live key and integrate with other [APIs](/api).

### M1 MacBook Changes

If you use M1 MacBook, you need to make the following changes in your podfile.

<Info>
  **Handy Tips**

  Add the following code inside `post_install do |installer|`.

  ```js: podfile theme={null}
  installer.pods_project.build_configurations.each do |config|
    config.build_settings["EXCLUDED_ARCHS[sdk=iphonesimulator*]"] = "arm64"
  end
  ```
</Info>

### 1.7 Verify Payment Status

<Info>
  **Handy Tips**

  On the Razorpay Dashboard, ensure that the payment status is `captured`. Refer to the payment capture settings page to know how to [capture payments automatically](/payments/payments/capture-settings).

  You can track the payment status in three ways:

  To verify the payment status from the Razorpay Dashboard:

  1. Log in to the Razorpay Dashboard and navigate to **Transactions** → **Payments**.
  2. Check if a **Payment Id** has been generated and note the status. In case of a successful payment, the status is marked as **Captured**.

  You can use Razorpay webhooks to configure and receive notifications when a specific event occurs. When one of these events is triggered, we send an HTTP POST payload in JSON to the webhook's configured URL. Know how to [set up webhooks.](/webhooks/setup-edit-payments)

  #### Example

  If you have subscribed to the `order.paid` webhook event, you will receive a notification every time a customer pays you for an order.

  [Poll Payment APIs](/api/payments/fetch-all-payments) to check the payment status.
</Info>

## 2. Test Integration

After the integration is complete, a **Pay** button appears on your webpage/app.

Click the button and make a test transaction to ensure the integration is working as expected. You can start accepting actual payments from your customers once the test transaction is successful.

<Warning>
  **Watch Out!**

  This is a mock payment page that uses your test API keys, test card and payment details.

  * Ensure you have entered only your [Test Mode API keys](/payments/dashboard/account-settings/api-keys#generate-api-keys) in the Checkout code.
  * Test mode features a mock bank page with **Success** and **Failure** buttons to replicate the live payment experience.
  * No real money is deducted due to the usage of test API keys. This is a simulated transaction.

  Following are all the payment modes that the customer can use to complete the payment on the Checkout. Some of them are available by default, while others may require approval from us. Raise a request from the Dashboard to enable such payment methods.

  ## Payment Method | Code | Availability

  ## [Debit Card](/payments/payment-methods/cards) | `debit` | ✓

  ## [Credit Card](/payments/payment-methods/cards) | `credit` | ✓

  ## [Netbanking](/payments/payment-methods/netbanking) | `netbanking`| ✓

  ## [UPI](/payments/payment-methods/upi) | `upi` | ✓

  ## EMI - [Credit Card EMI](/payments/payment-methods/emi/credit-card-emi), [Debit Card EMI](/payments/payment-methods/emi/debit-card-emi) and [No Cost EMI](/payments/payment-methods/emi/no-cost-emi) | `emi` | ✓

  ## [Wallet](/payments/payment-methods/wallets) | `wallet` | ✓

  ## [Cardless EMI](/payments/payment-methods/emi/cardless-emi) | `cardless_emi` | Requires [Approval](https://razorpay.com/support).

  ## [Bank Transfer](/payments/payment-methods/bank-transfer) | `bank_transfer` | Requires [Approval](https://razorpay.com/support) and Integration.

  ## [Emandate](/payments/recurring-payments/emandate/integrate) | `emandate` | Requires [Approval](https://razorpay.com/support) and Integration.

  [Pay Later](/payments/payment-methods/pay-later)| `paylater` | Requires [Approval](https://razorpay.com/support).

  You can make test payments using one of the payment methods configured at the Checkout.
</Warning>

### Netbanking

You can select any of the listed banks. After choosing a bank, Razorpay will redirect to a mock page where you can make the payment `success` or a `failure`. Since this is Test Mode, we will not redirect you to the bank login portals.

Check the list of [supported banks](/payments/payment-methods/netbanking#supported-banks).

### UPI

You can enter one of the following UPI IDs:

* `success@razorpay`: To make the payment successful.
* `failure@razorpay`: To fail the payment.

Check the list of [supported UPI flows](/payments/payment-methods/upi).

<Info>
  **Handy Tips**

  You can use **Test Mode** to test UPI payments, and **Live Mode** for UPI Intent and QR payments.
</Info>

### Cards

You can use the following test cards to test transactions for your integration in Test Mode.

### Domestic Cards

Use the following test cards for Indian payments:

## Network | Card Number | CVV & Expiry Date

## Visa  | 4100 2800 0000 1007 | Use a random CVV and any future date ^^^^^

## Mastercard | 5500 6700 0000 1002 |

## RuPay | 6527 6589 0000 1005 |

## Diners | 3608 280009 1007 |

Amex | 3402 560004 01007 |

#### Error Scenarios

Use these test cards to simulate payment errors. See the [complete list](/payments/payments/test-card-details#error-scenario-test-cards) of error test cards with detailed scenarios.
Check the following lists:

* [Supported Card Networks](/payments/payment-methods/cards).
* [Cards Error Codes](/errors/payments/cards).

### International Cards

Use the following test cards to test international payments. Use any valid expiration date in the future in the MM/YY format and any random CVV to create a successful payment.

## Card Network | Card Number | CVV & Expiry Date

Mastercard | 5555 5555 5555 4444
5105 1051 0510 5100
5104 0600 0000 0008 | Use a random CVV and any future date ^^
-------------------------------------------------------------

Visa | 4012 8888 8888 1881 |

Check the list of [supported card networks](/payments/payment-methods/cards).

### Wallet

You can select any of the listed wallets. After choosing a wallet, Razorpay will redirect to a mock page where you can make the payment `success` or a `failure`. Since this is Test Mode, we will not redirect you to the wallet login portals.

Check the list of [supported wallets](/payments/payment-methods/wallets#supported-wallets).

## 3. Go-live Checklist

Check the go-live checklist for Razorpay React Native Android integration. Consider these steps before taking the integration live.

### 3.1 Accept Live Payments

Perform an end-to-end simulation of funds flow in the Test Mode. Once confident that the integration is working as expected, switch to the Live Mode and start accepting payments from customers.

<Warning>
  **Watch Out!**

  Ensure you are switching your test API keys with API keys generated in Live Mode.

  To generate API Keys in Live Mode on your Razorpay Dashboard:

  1. Log in to the Razorpay Dashboard and switch to **Live Mode** on the menu.
  2. Navigate to **Account & Settings** → **API Keys** → **Generate Key** to generate the API Key for Live Mode.
  3. Download the keys and save them securely.
  4. Replace the Test API Key with the Live Key in the Checkout code and start accepting actual payments.
</Warning>

### 3.2 Payment Capture

After payment is `authorized`, you need to capture it to settle the amount to your bank account as per the settlement schedule. Payments that are not captured are auto-refunded after a fixed time.

<Warning>
  **Watch Out**

  * You should deliver the products or services to your customers only after the payment is captured. Razorpay automatically refunds all the uncaptured payments.
  * You can track the payment status using our [Fetch a Payment API](/api/payments#fetch-a-payment) or webhooks.

    Authorized payments can be automatically captured. You can auto-capture all payments [using global settings](/payments/payments/capture-settings#auto-capture-all-payments) on the Razorpay Dashboard. Know more about [capture settings for payments](/payments/payments/capture-settings).
</Warning>

<Warning>
  **Watch Out!**

  Payment capture settings work only if you have integrated with Orders API on your server side. Know more about the [Orders API](/api/orders/create).

  Each authorized payment can also be captured individually. You can manually capture payments using [Payment Capture API](/api/payments#capture-a-payment) or [Dashboard](/payments/payments/dashboard#manually-capture-payments). Know more about [capture settings for payments](/payments/payments/capture-settings).
</Warning>

### 3.3 Set Up Webhooks

Ensure you have [set up webhooks](/webhooks/setup-edit-payments) in the live mode and configured the events for which you want to receive notifications.

<Warning>
  **Implementation Considerations**

  Webhooks are the primary and most efficient method for event notifications. They are delivered asynchronously in near real-time. For critical user-facing flows that need instant confirmation (like showing "Payment Successful" immediately), supplement webhooks with API verification.

  **Recommended approach**

  * Rely on webhooks for all automation, which can be asynchronous.
  * If a critical user-facing flow requires instant status, but the webhook notification has not arrived within the time mandated by your business needs, perform an immediate API Fetch call ([Payments](/api/payments/fetch-with-id), [Orders](/api/orders/fetch-with-id) and [Refunds](/api/refunds/fetch-specific-refund-payment)) to verify the status.
</Warning>
